<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PDF OCR Viewer</title>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.11.3/font/bootstrap-icons.min.css">
<style>
  #container{
    display: flex;
    gap: 20px;
    height: 100vh;
    margin: 20px;
  }
  #pdf-container{
    position: relative;
    width: 50%;
  }
/*  canvas {
    border: 1px solid #000;
  }*/

  #text-container{
    width: 50%;
  }
  #overlay{
    position: absolute;
    top: 0;
    left: 0;
    pointer-events: none;
  }
  .left-pane,.right-pane{
    flex: 1;
    overflow: auto;
    padding: 10px;
    border: 1px solid #ccc;
  }
  .paragraph {
    cursor: pointer;
    padding: 5px;
    margin: 5px 0;
    border: 1px solid transparent;
  }

  .paragraph:hover, .paragraph.selected {
    border: 1px solid blue;
    background-color: #f0f8ff;
  }
  textarea {
    resize: none; /* Prevent manual resizing */
    overflow: hidden; /* Hide scrollbars */
    border: none; /* Remove border */
    outline: none; /* Remove focus outline */
    width: 100%; /* Match parent width */
    box-sizing: border-box; /* Include padding in width calculation */
  }
  #form-div{
    display: flex;
    justify-content: center;
    align-items: center;
  }
  button{
    width: 100px;
    height: 50px;
  }
  #icon-div{
    display: flex;
    justify-content: center;
    align-items: row;
    gap: 10px;
  }
  #zoom-div{
    margin-top: 25px;
    display: flex;
    justify-content: center;
    align-items: center;
    gap: 10px;
  }

</style>
</head>
<body>
  <form id = "form-01" action="./" method="post">
    <div id="icon-div">

      <div onclick="pageNav('fullBackward')" >
        <svg  xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-skip-backward-fill" viewBox="0 0 16 16">
          <path d="M.5 3.5A.5.5 0 0 0 0 4v8a.5.5 0 0 0 1 0V8.753l6.267 3.636c.54.313 1.233-.066 1.233-.697v-2.94l6.267 3.636c.54.314 1.233-.065 1.233-.696V4.308c0-.63-.693-1.01-1.233-.696L8.5 7.248v-2.94c0-.63-.692-1.01-1.233-.696L1 7.248V4a.5.5 0 0 0-.5-.5"/>
        </svg>
    </div>

    <div onclick="pageNav('backward')" >
      <svg  xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-rewind-fill" viewBox="0 0 16 16">
        <path d="M8.404 7.304a.802.802 0 0 0 0 1.392l6.363 3.692c.52.302 1.233-.043 1.233-.696V4.308c0-.653-.713-.998-1.233-.696z"/>
        <path d="M.404 7.304a.802.802 0 0 0 0 1.392l6.363 3.692c.52.302 1.233-.043 1.233-.696V4.308c0-.653-.713-.998-1.233-.696z"/>
      </svg>
    </div>

      <select name="pageNumber" id="selectPage">
        <option value="1">1</option>
      </select>

      <div onclick="pageNav('forward')" >
      <svg  xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-fast-forward-fill" viewBox="0 0 16 16">
        <path d="M7.596 7.304a.802.802 0 0 1 0 1.392l-6.363 3.692C.713 12.69 0 12.345 0 11.692V4.308c0-.653.713-.998 1.233-.696z"/>
        <path d="M15.596 7.304a.802.802 0 0 1 0 1.392l-6.363 3.692C8.713 12.69 8 12.345 8 11.692V4.308c0-.653.713-.998 1.233-.696z"/>
      </svg>
    </div>

    <div onclick="pageNav('fullForward')" >
      <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-skip-forward-fill" viewBox="0 0 16 16">
        <path d="M15.5 3.5a.5.5 0 0 1 .5.5v8a.5.5 0 0 1-1 0V8.753l-6.267 3.636c-.54.313-1.233-.066-1.233-.697v-2.94l-6.267 3.636C.693 12.703 0 12.324 0 11.693V4.308c0-.63.693-1.01 1.233-.696L7.5 7.248v-2.94c0-.63.693-1.01 1.233-.696L15 7.248V4a.5.5 0 0 1 .5-.5"/>
      </svg>
    </div>
    </div>

    <div id="zoom-div">

      <svg id="zoom-in" xmlns="http://www.w3.org/2000/svg" width="25" height="25" fill="currentColor" class="bi bi-zoom-in" viewBox="0 0 16 16">
        <path fill-rule="evenodd" d="M6.5 12a5.5 5.5 0 1 0 0-11 5.5 5.5 0 0 0 0 11M13 6.5a6.5 6.5 0 1 1-13 0 6.5 6.5 0 0 1 13 0"/>
        <path d="M10.344 11.742q.044.06.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1 1 0 0 0-.115-.1 6.5 6.5 0 0 1-1.398 1.4z"/>
        <path fill-rule="evenodd" d="M6.5 3a.5.5 0 0 1 .5.5V6h2.5a.5.5 0 0 1 0 1H7v2.5a.5.5 0 0 1-1 0V7H3.5a.5.5 0 0 1 0-1H6V3.5a.5.5 0 0 1 .5-.5"/>
      </svg>

      <svg id="zoom-out" xmlns="http://www.w3.org/2000/svg" width="25" height="25" fill="currentColor" class="bi bi-zoom-out" viewBox="0 0 16 16">
        <path fill-rule="evenodd" d="M6.5 12a5.5 5.5 0 1 0 0-11 5.5 5.5 0 0 0 0 11M13 6.5a6.5 6.5 0 1 1-13 0 6.5 6.5 0 0 1 13 0"/>
        <path d="M10.344 11.742q.044.06.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1 1 0 0 0-.115-.1 6.5 6.5 0 0 1-1.398 1.4z"/>
        <path fill-rule="evenodd" d="M3 6.5a.5.5 0 0 1 .5-.5h6a.5.5 0 0 1 0 1h-6a.5.5 0 0 1-.5-.5"/>
      </svg>

    </div>

    <div id="container">
        <!-- Left Pane: PDF Viewer -->
        <div id="pdf-container" class="left-pane" >
          <canvas id="pdf-canvas"></canvas>
          <svg id="overlay" ></svg>
        </div>

        <!-- Right Pane: Text Content -->
        <div id="text-container" class="right-pane" ></div>
      </div>
      <div id="form-div">
      <button id="submit-btn" type="submit">Submit</button>
    </div>
    </form>
    <script>
  //    const selectPages = document.getElementById("selectPage");
  const selectPage = document.getElementById("selectPage");
      function pageNav(inputBtn){
        let pageNum = parseInt(selectPage.value);
        //console.log(inputBtn);
        if( inputBtn == "fullBackward"){
          selectPage.value = 1;
        }else if (inputBtn == "backward" && pageNum > 1){
          selectPage.value = pageNum-1;
        }else if (inputBtn == "forward" && pageNum < selectPage.length){
          selectPage.value = pageNum+1;
        }else if (inputBtn == "fullForward"){
          selectPage.value = selectPage.length;
        }
        const event = new Event('change', { bubbles: true, cancelable: true });
        selectPage.dispatchEvent(event);
     //  console.log()
     };
       </script>
<script type="module">
  import { renderPDFWithBoundingBoxes } from './ocr_viewer.mjs';

  const form = document.getElementById('form-01');
  const selectPages = document.getElementById("selectPage");
  const textContainer = document.getElementById("text-container");
  const icon = document.getElementById("icon-div");
  const zoomOut = document.getElementById("zoom-out");
  const zoomIn = document.getElementById("zoom-in");
  let zoomFactor = 1;







  let pdfUrl = "asset/Baglamukhi.pdf";
  let pageNum = selectPages.value;
  //console.log(pageNum);
  let apiUrl = "https://api.siddhantakosha.org/ikmldata?expand_inline=1&gpath=libraries%2Fe-kosha%2F1-10-part1%2FTreasures+(2674)%2FDatia+and+Others%2FDatia%2FBaglamukhi+Rahasyam+-+Datia+Peeth_0423%2FBaglamukhi+Rahasyam+-+Datia+Peeth_0423-ikml-page-"+String(1).padStart(3, '0')+"-ikml.txt&eleid=&email=public%40example.com&token=474b227672a6c486098d372472c287e0&fmt=json";
  //console.log(apiUrl);
  let arrayOfData = [];
  let data = function(pdfUrl,apiUrl,pageNum,zoomFactor) {fetch(apiUrl)
.then(response => response.json())
.then(data => {
  arrayOfData.length = 0;
  data.children.forEach((block) => block.children.forEach((paragraph) => {
    arrayOfData.push({
      "bbox": paragraph['.bbox'],
      "text": paragraph.children.map((child) =>{
         return {
          "content" :child.content,
          "content_id":child.id+"_"+child.rel_id
        };
    }),
      "paragraph_rel_id": paragraph.rel_id,
      "paragraph_id": paragraph.id
    })

  }));
  //console.log(arrayOfData);

   renderPDFWithBoundingBoxes({
    pdfUrl: pdfUrl,
    pageNum: parseInt(pageNum),
    pageWidth: data[".width"], // Target width for the PDF page
    pageHeight: data[".height"], // Target height for the PDF page
    zoomFactor: zoomFactor,
    arrayOfData: arrayOfData,
  })

}

)
.catch(error => {
  textContainer.innerHTML = "Can not fetch data. Please Contact Administrator";
  console.error(error)
});
//console.log(pageInputData);
  }
//  console.log(data());
 window.addEventListener('resize', data(pdfUrl,apiUrl,pageNum,zoomFactor));

  // Zoom in
  zoomIn.addEventListener('click', () => {
    zoomFactor += 0.1; // Increase zoom factor
    data(pdfUrl,apiUrl,pageNum,zoomFactor);
  });

  // Zoom out
  zoomOut.addEventListener('click', () => {
    if (zoomFactor > 0.2) { // Prevent zooming out too much
      zoomFactor -= 0.1; // Decrease zoom factor
      data(pdfUrl,apiUrl,pageNum,zoomFactor);
    }
  });


 selectPages.addEventListener('change', (event) => {
   pageNum = event.target.value;
   //console.log(pageNum);
   textContainer.innerHTML = "";
   let pageForApi = 1;
   if(pageNum < 6){
    pageForApi = 1;
  }else{
    pageForApi = pageNum-5
  }
  //console.log(pageForApi);
  apiUrl = "https://api.siddhantakosha.org/ikmldata?expand_inline=1&gpath=libraries%2Fe-kosha%2F1-10-part1%2FTreasures+(2674)%2FDatia+and+Others%2FDatia%2FBaglamukhi+Rahasyam+-+Datia+Peeth_0423%2FBaglamukhi+Rahasyam+-+Datia+Peeth_0423-ikml-page-"+String(pageForApi).padStart(3, '0')+"-ikml.txt&eleid=&email=public%40example.com&token=474b227672a6c486098d372472c287e0&fmt=json";
  //console.log(apiUrl);
  data(pdfUrl,apiUrl,pageNum,zoomFactor)
 });





  form.addEventListener('submit', (event) => {
    event.preventDefault();
    const inputFields = document.querySelectorAll('textarea');
    (inputFields.forEach(element => {
      alert("Name of textarea is =>"+element.name+". Value is =>"+ element.value);
    }))

  });



//actual code begin from this point

    </script>

</body>
</html>
